searchNodes=[{"ref":"Etso.Adapter.html","title":"Etso.Adapter","type":"module","doc":"Used as an Adapter in Repo modules, which transparently spins up one ETS table for each Schema used with the Repo, namespaced to the Repo to allow concurrent running of multiple Repositories."},{"ref":"Etso.Adapter.html#autogenerate/1","title":"Etso.Adapter.autogenerate/1","type":"function","doc":"Called to autogenerate a value for id/embed_id/binary_id. Returns the autogenerated value, or nil if it must be autogenerated inside the storage or raise if not supported. Callback implementation for Ecto.Adapter.Schema.autogenerate/1."},{"ref":"Etso.Adapter.html#checkout/3","title":"Etso.Adapter.checkout/3","type":"function","doc":"Checks out a connection for the duration of the given function. In case the adapter provides a pool, this guarantees all of the code inside the given fun runs against the same connection. Callback implementation for Ecto.Adapter.checkout/3."},{"ref":"Etso.Adapter.html#delete/4","title":"Etso.Adapter.delete/4","type":"function","doc":"Deletes a single struct with the given filters. While filters can be any record column, it is expected that at least the primary key (or any other key that uniquely identifies an existing record) be given as a filter. Therefore, in case there is no record matching the given filters, {:error, :stale} is returned. Callback implementation for Ecto.Adapter.Schema.delete/4."},{"ref":"Etso.Adapter.html#dumpers/2","title":"Etso.Adapter.dumpers/2","type":"function","doc":"Returns the dumpers for a given type. It receives the primitive type and the Ecto type (which may be primitive as well). It returns a list of dumpers with the given type usually at the beginning. This allows developers to properly translate values coming from the Ecto into adapter ones. For example, if the database does not support booleans but instead returns 0 and 1 for them, you could add: def dumpers(:boolean, type), do: [type, &amp;bool_encode/1] def dumpers(_primitive, type), do: [type] defp bool_encode(false), do: {:ok, 0} defp bool_encode(true), do: {:ok, 1} All adapters are required to implement a clause for :binary_id types, since they are adapter specific. If your adapter does not provide binary ids, you may simply use Ecto.UUID: def dumpers(:binary_id, type), do: [type, Ecto.UUID] def dumpers(_primitive, type), do: [type] Callback implementation for Ecto.Adapter.dumpers/2."},{"ref":"Etso.Adapter.html#ensure_all_started/2","title":"Etso.Adapter.ensure_all_started/2","type":"function","doc":"Ensure all applications necessary to run the adapter are started. Callback implementation for Ecto.Adapter.ensure_all_started/2."},{"ref":"Etso.Adapter.html#execute/5","title":"Etso.Adapter.execute/5","type":"function","doc":"Executes a previously prepared query. It must return a tuple containing the number of entries and the result set as a list of lists. The result set may also be nil if a particular operation does not support them. The adapter_meta field is a map containing some of the fields found in the Ecto.Query struct. Callback implementation for Ecto.Adapter.Queryable.execute/5."},{"ref":"Etso.Adapter.html#init/1","title":"Etso.Adapter.init/1","type":"function","doc":"Initializes the adapter supervision tree by returning the children and adapter metadata. Callback implementation for Ecto.Adapter.init/1."},{"ref":"Etso.Adapter.html#insert/6","title":"Etso.Adapter.insert/6","type":"function","doc":"Inserts a single new struct in the data store. Autogenerate The primary key will be automatically included in returning if the field has type :id or :binary_id and no value was set by the developer or none was autogenerated by the adapter. Callback implementation for Ecto.Adapter.Schema.insert/6."},{"ref":"Etso.Adapter.html#insert_all/7","title":"Etso.Adapter.insert_all/7","type":"function","doc":"Inserts multiple entries into the data store. In case an Ecto.Query given as any of the field values by the user, it will be sent to the adapter as a tuple with in the shape of {query, params}. Callback implementation for Ecto.Adapter.Schema.insert_all/7."},{"ref":"Etso.Adapter.html#loaders/2","title":"Etso.Adapter.loaders/2","type":"function","doc":"Returns the loaders for a given type. It receives the primitive type and the Ecto type (which may be primitive as well). It returns a list of loaders with the given type usually at the end. This allows developers to properly translate values coming from the adapters into Ecto ones. For example, if the database does not support booleans but instead returns 0 and 1 for them, you could add: def loaders(:boolean, type), do: [&amp;bool_decode/1, type] def loaders(_primitive, type), do: [type] defp bool_decode(0), do: {:ok, false} defp bool_decode(1), do: {:ok, true} All adapters are required to implement a clause for :binary_id types, since they are adapter specific. If your adapter does not provide binary ids, you may simply use Ecto.UUID: def loaders(:binary_id, type), do: [Ecto.UUID, type] def loaders(_primitive, type), do: [type] Callback implementation for Ecto.Adapter.loaders/2."},{"ref":"Etso.Adapter.html#prepare/2","title":"Etso.Adapter.prepare/2","type":"function","doc":"Commands invoked to prepare a query for all, update_all and delete_all. The returned result is given to execute/6. Callback implementation for Ecto.Adapter.Queryable.prepare/2."},{"ref":"Etso.Adapter.html#stream/5","title":"Etso.Adapter.stream/5","type":"function","doc":"Streams a previously prepared query. It returns a stream of values. The adapter_meta field is a map containing some of the fields found in the Ecto.Query struct. Callback implementation for Ecto.Adapter.Queryable.stream/5."},{"ref":"Etso.Adapter.html#update/6","title":"Etso.Adapter.update/6","type":"function","doc":"Updates a single struct with the given filters. While filters can be any record column, it is expected that at least the primary key (or any other key that uniquely identifies an existing record) be given as a filter. Therefore, in case there is no record matching the given filters, {:error, :stale} is returned. Callback implementation for Ecto.Adapter.Schema.update/6."},{"ref":"Etso.Adapter.Behaviour.Queryable.html","title":"Etso.Adapter.Behaviour.Queryable","type":"module","doc":""},{"ref":"Etso.Adapter.Behaviour.Schema.html","title":"Etso.Adapter.Behaviour.Schema","type":"module","doc":""},{"ref":"Etso.Adapter.Meta.html","title":"Etso.Adapter.Meta","type":"module","doc":""},{"ref":"Etso.Adapter.Meta.html#t:t/0","title":"Etso.Adapter.Meta.t/0","type":"type","doc":""},{"ref":"Etso.Adapter.Supervisor.html","title":"Etso.Adapter.Supervisor","type":"module","doc":"Supervision tree which supports the ETS Adapter. There are several children used in the tree: a Dynamic Supervisor to hold the Table Servers a Registry to keep track of the Table Servers"},{"ref":"Etso.Adapter.Supervisor.html#child_spec/1","title":"Etso.Adapter.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Etso.Adapter.Supervisor.html#start_link/1","title":"Etso.Adapter.Supervisor.start_link/1","type":"function","doc":""},{"ref":"Etso.Adapter.TableRegistry.html","title":"Etso.Adapter.TableRegistry","type":"module","doc":"Provides convenience functions used by the Table Server to register their ETS tables, and by the Adapter itself to get the ETS tables."},{"ref":"Etso.Adapter.TableRegistry.html#child_spec/1","title":"Etso.Adapter.TableRegistry.child_spec/1","type":"function","doc":""},{"ref":"Etso.Adapter.TableRegistry.html#get_table/2","title":"Etso.Adapter.TableRegistry.get_table/2","type":"function","doc":""},{"ref":"Etso.Adapter.TableRegistry.html#name/1","title":"Etso.Adapter.TableRegistry.name/1","type":"function","doc":""},{"ref":"Etso.Adapter.TableRegistry.html#register_table/3","title":"Etso.Adapter.TableRegistry.register_table/3","type":"function","doc":""},{"ref":"Etso.Adapter.TableServer.html","title":"Etso.Adapter.TableServer","type":"module","doc":""},{"ref":"Etso.Adapter.TableServer.html#child_spec/1","title":"Etso.Adapter.TableServer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Etso.Adapter.TableServer.html#init/1","title":"Etso.Adapter.TableServer.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Etso.Adapter.TableServer.html#start_link/1","title":"Etso.Adapter.TableServer.start_link/1","type":"function","doc":""},{"ref":"Etso.Adapter.TableSupervisor.html","title":"Etso.Adapter.TableSupervisor","type":"module","doc":"Provides convenience functions to spin up a Dynamic Supervisor"},{"ref":"Etso.Adapter.TableSupervisor.html#child_spec/1","title":"Etso.Adapter.TableSupervisor.child_spec/1","type":"function","doc":""},{"ref":"Etso.Adapter.TableSupervisor.html#name/1","title":"Etso.Adapter.TableSupervisor.name/1","type":"function","doc":""},{"ref":"Etso.ETS.MatchSpecification.html","title":"Etso.ETS.MatchSpecification","type":"module","doc":""},{"ref":"Etso.ETS.MatchSpecification.html#build/2","title":"Etso.ETS.MatchSpecification.build/2","type":"function","doc":""},{"ref":"Etso.ETS.TableStructure.html","title":"Etso.ETS.TableStructure","type":"module","doc":""},{"ref":"Etso.ETS.TableStructure.html#entries_to_tuples/2","title":"Etso.ETS.TableStructure.entries_to_tuples/2","type":"function","doc":""},{"ref":"Etso.ETS.TableStructure.html#field_names/1","title":"Etso.ETS.TableStructure.field_names/1","type":"function","doc":""},{"ref":"Etso.ETS.TableStructure.html#fields_to_tuple/2","title":"Etso.ETS.TableStructure.fields_to_tuple/2","type":"function","doc":""},{"ref":"readme.html","title":"Etso","type":"extras","doc":"Etso"},{"ref":"readme.html#overview","title":"Etso - Overview","type":"extras","doc":"Etso is an ETS adapter, allowing you to use Ecto schemas with ETS tables. Within this library, a bare-bones Ecto Adapter is provided. The Adapter transparently spins up ETS tables for each Ecto Repo and Schema combination. The tables are publicly accessible to enable concurrency, and tracked by reference to ensure encapsulation. Each ETS table is spun up by a dedicated Table Server under a shared Dynamic Supervisor. For a detailed look as to what is available, check out Northwind Repo Test."},{"ref":"readme.html#highlights-benefits","title":"Etso - Highlights &amp; Benefits","type":"extras","doc":"Key highlights of this library are: It transparently handles translations between Ecto.Schema structs and ETS tuples. It knows how to form ETS Match Specifications for simple queries. Key points to consider when adopting this library are: It is suitable for rapid retrieval of simply formatted data, for example presets that do not change frequently. It is not suitable for use as a full-fledged data layer unless your requirements are simple."},{"ref":"readme.html#feature-coverage","title":"Etso - Feature Coverage","type":"extras","doc":"The following features are working: Basic query scenarios (C / R / U / D): insert all, insert one, get by ID, where, delete by ID. Selects Assocs Preloads The following features, for example, are missing: Aggregates (dynamic / static) Joins Windows Transactions Migrations Locking"},{"ref":"readme.html#installation","title":"Etso - Installation","type":"extras","doc":"Using Etso is a two-step process. First, include it in your application’s dependencies: defp deps do [ {:etso, &quot;~&gt; 0.1.0&quot;} ] end Afterwards, create a new Ecto.Repo, which uses Etso.Adapter: defmodule MyApp.Repo do @otp_app Mix.Project.config()[:app] use Ecto.Repo, otp_app: @otp_app, adapter: Etso.Adapter end Once this is done, you can use any Schema against the Repo normally, as you would with any other Repo. Check out the Northwind modules for an example."},{"ref":"readme.html#utilisation","title":"Etso - Utilisation","type":"extras","doc":"Originally, Etso was created to answer the question of whether ETS and Ecto can be married together. It has since found some uses in production applications, serving as a Data Repository for pre-defined nested content. This proved invaluable for rapid iteration. (If you have other Use Cases for this library, please add it here with a Pull Request.)"},{"ref":"readme.html#further-note","title":"Etso - Further Note","type":"extras","doc":"This repository is extracted from a prior project ETS Playground, which was created to support my session at ElixirConf EU 2019, Leveraging ETS Effectively."},{"ref":"readme.html#acknowledgements","title":"Etso - Acknowledgements","type":"extras","doc":"This project contains a copy of data obtained from the Northwind database, which is owned by Microsoft. It is included for demonstration and testing purposes only, and is excluded from the distribution. The Author thanks Microsoft Corporation for the inspiration. The Author also wishes to thank the following individuals: Wojtek Mach, for the inspiration regarding creation of an Ecto adapter for ETS. Steven Holdsworth, for initial concept proofing and refinement. Igor Kopestenski, for initial reviews. David Schainker, for initial reviews, and for finding uses for this library."}]